/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// DataSource `output` is special data source, which is available only in actions used as output handlers.
type DataSource string

// List of DataSource
const (
	STATIC DataSource = "static"
	EVENT DataSource = "event"
	CONTACT DataSource = "contact"
	TX DataSource = "tx"
	CODE DataSource = "code"
	SEGMENTS DataSource = "segments"
	LABELS DataSource = "labels"
	OUTPUT DataSource = "output"
	MOBILE_DEVICE DataSource = "mobile_device"
)

// All allowed values of DataSource enum
var AllowedDataSourceEnumValues = []DataSource{
	"static",
	"event",
	"contact",
	"tx",
	"code",
	"segments",
	"labels",
	"output",
	"mobile_device",
}

func (v *DataSource) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := DataSource(value)
	for _, existing := range AllowedDataSourceEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid DataSource", value)
}

// NewDataSourceFromValue returns a pointer to a valid DataSource
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewDataSourceFromValue(v string) (*DataSource, error) {
	ev := DataSource(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for DataSource: valid values are %v", v, AllowedDataSourceEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v DataSource) IsValid() bool {
	for _, existing := range AllowedDataSourceEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to DataSource value
func (v DataSource) Ptr() *DataSource {
	return &v
}

type NullableDataSource struct {
	value *DataSource
	isSet bool
}

func (v NullableDataSource) Get() *DataSource {
	return v.value
}

func (v *NullableDataSource) Set(val *DataSource) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSource) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSource) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSource(val *DataSource) *NullableDataSource {
	return &NullableDataSource{value: val, isSet: true}
}

func (v NullableDataSource) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSource) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

